// File name: I2S_PMod_top.vs
//
// 01Aug2012 .. version started .. K.Metzger
//
module I2S_PMod_top(	
	inout [31:0] GPIO_1,
	output [17:0] LEDR,
	input [15:0] SW,
	input CLOCK_28,
	input CLOCK_50,
	output [7:0] HEX0,
	output [7:0] HEX1
);

	logic i2s_fs, i2s_clk, i2s_rx, i2s_tx, clk, CLOCK_25, ad_rx;
	logic [15:0] received_word, transmit_word, ctr, next_ctr;
	logic transmit_empty_flag, transmit_load;
	logic next_transmit_load;

	// Use J6 on FPGA breakout board
	
	assign GPIO_1[15] = i2s_clk;
	assign GPIO_1[14] = i2s_tx;
	assign i2s_rx = GPIO_1[13];
	assign GPIO_1[12] = i2s_fs;
	
	// IO stuff 
	
	// ADD CODE HERE TO USE SWITCHES FOR VALUE TO TRANSMIT
	// ALSO DISPLAY USING HEXDISPLAY MODULE THE VALUE TRANSMITTED AND RECEIVED

	I2S_master master(
		.received_word(received_word),
		.transmit_word(transmit_word),
		.transmit_empty_flag(transmit_empty_flag),
		.transmit_load(transmit_load),
		.i2s_fs(i2s_fs),
		.i2s_clk(i2s_clk),
		.i2s_rx(i2s_rx),
		.i2s_tx(i2s_tx),
		.clk(CLOCK_50));
		
	assign clk = CLOCK_25;
	always_ff@(posedge CLOCK_50) CLOCK_25 <= ~CLOCK_25;
	always_ff@(posedge clk) begin
		ctr <= next_ctr;
		transmit_load <= next_transmit_load;
	end	
	always_comb begin
		next_ctr <= ctr;
		next_transmit_load <= 0;
		
		if (transmit_empty_flag) begin
			next_transmit_load <= 1;
			next_ctr <= ctr+16'b1;
		end
	end	
	
endmodule	