module hexDisplay(bin, hex);	
	parameter n0 = 8'b11000000;
	parameter n1 = 8'b11111001;
	parameter n2 = 8'b10100100;
	parameter n3 = 8'b10110000;
	parameter n4 = 8'b10011001;
	parameter n5 = 8'b10010010;
	parameter n6 = 8'b10000010;
	parameter n7 = 8'b11111000;
	parameter n8 = 8'b10000000;
	parameter n9 = 8'b10011000;
	parameter na = 8'b10001000;
	parameter nb = 8'b10000011;
	parameter nc = 8'b11000110;
	parameter nd = 8'b10100001;
	parameter ne = 8'b10000110;
	parameter nf = 8'b10001110;
	
	input  [3:0] bin;
	output [7:0] hex;
	assign hex = 	(bin == 4'h0) ? n0:
						(bin == 4'h1) ? n1:
						(bin == 4'h2) ? n2:
						(bin == 4'h3) ? n3:
						(bin == 4'h4) ? n4:
						(bin == 4'h5) ? n5:
						(bin == 4'h6) ? n6:
						(bin == 4'h7) ? n7:
						(bin == 4'h8) ? n8:
						(bin == 4'h9) ? n9:
						(bin == 4'ha) ? na:
						(bin == 4'hb) ? nb:
						(bin == 4'hc) ? nc:
						(bin == 4'hd) ? nd:
						//Fill in the missing ones here.
						(bin == 4'he) ? ne: nf;
endmodule