module fpgaSpiSlave(iCLK_28, iCLK_25, iCLK_50, iSW, GPIO_1, oLEDG, oLEDR, HEX0, HEX1);
input iCLK_25;
input iCLK_50;
input iCLK_28;
input [15:0] iSW;
inout [7:0] GPIO_1;
output [8:0] oLEDG;
output [15:0] oLEDR;
output [7:0] HEX0;
output [7:0] HEX1;

wire SSEL = GPIO_1[0];
wire SCLK = GPIO_1[1];
wire MOSI = GPIO_1[2];
wire MISO;
assign GPIO_1[3] = MISO;

wire [15:0] packetSend = iSW[15:0];
wire [15:0] packetReceive;
wire			received;

assign oLEDG = iSW[8:0];
assign oLEDR = packetReceive;

spiSlave slave(
	.clk(iCLK_50),
	.sclk(SCLK),
	.ssel(SSEL),
	.mosi(MOSI),
	.miso(MISO),
	.packetReceive(packetReceive),
	.packetSend(packetSend),
	.received(received)
);

reg [15:0] receivedReg;
always @(posedge received)
begin
	receivedReg = packetReceive;
end
wire [15:0] gotten = receivedReg;

hexDisplay hex0(gotten[3:0], HEX0);
hexDisplay hex1(packetSend[3:0], HEX1);

endmodule