// We've left 4 lines in this code for you to fill out, they are numbered.
module spiSlave(
	clk,
	sclk,
	ssel,
	mosi,
	miso,
	packetSend,
	packetReceive,
	received
);
input clk, sclk, ssel, mosi;
input [15:0] packetSend;
output [15:0] packetReceive;
output received;
output miso = misoDataRegister[15];

// detect the rise and fall of the SCLK
reg [2:0] sclkReg; //3 bits  
always @(posedge clk) 
begin
	sclkReg <= {sclkReg[1:0], sclk};
end
wire sclkRising = (sclkReg[2:1]== 2'b01);  // now we can detect SCK rising edges
wire sclkFalling = // 1. Fill in this statement! // and falling edges

// assuming the master is using SPI mod 1: active low, mosi on rising edge
// detect the rise and fall of the SSEL
reg [2:0] sselReg; //3 bits
always @(posedge clk)
begin
	sselReg <= {sselReg[1:0], ssel};
end
wire sselActive = ~sselReg[1];  // SSEL is active low
wire msgStart = (sselReg[2:1]==2'b10);  // miso starts at falling edge
wire msgEnd = // 2. Fill in this statement!  // miso stops at rising edge

// shift register for mosi data
reg [1:0] mosiReg;  
always @(posedge clk)
begin
	mosiReg <= {mosiReg[0], mosi};
end
wire mosiData = mosiReg[1];

// receive logic
reg [3:0] bitsSeen = 4'b0000;
reg [15:0] packetReceiveReg;
assign packetReceive = packetReceiveReg;
reg received; //ticks when entire 16 bit word is received
reg [15:0] mosiDataRegister;
always @(posedge clk)
begin
	if (~sselActive)
		bitsSeen <= 4'b0000;
	else
	if (sclkRising)
	begin
		bitsSeen <= bitsSeen + 4'b0001;
		mosiDataRegister <= // 3. Complete this line!
	end
	received <= sselActive && sclkRising && (bitsSeen == 4'b1111);
end
always @(posedge clk)
begin
	if(received)
	begin
		packetReceiveReg <= mosiDataRegister;
	end
end

// transmit logic
reg [15:0] misoDataRegister;
always @(posedge clk)
if(sselActive)
begin
  if(msgStart)
    misoDataRegister <= packetSend;  // first byte sent in a message is the message count
  else
  if(sclkFalling)
  begin
    if(bitsSeen==4'b0000)
      misoDataRegister <= 16'h0000;  // after that, we send 0s
    else
      misoDataRegister <= // 4. Complete this line!
  end
end

endmodule